/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 189 by dpavlin, Tue Mar 16 23:05:31 2010 UTC revision 233 by dpavlin, Sun Oct 24 12:23:20 2010 UTC
# Line 16  Line 16 
16  #  #
17  # based on Tony Risinger post to lxc-users mailing list  # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
# Line 33  lxc_exists() { Line 37  lxc_exists() {
37    
38    
39  lxc_rootfs() {  lxc_rootfs() {
40          grep lxc.rootfs "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41    }
42    
43    lxc_hostname() {
44            inside=`cat $(lxc_rootfs $1)/etc/hostname`
45            config=`grep lxc.utsname /var/lib/lxc/$name/config | cut -d= -f2`
46            echo "$config [$inside]";
47  }  }
48    
49    lxc_ip() {
50            ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | cut -d= -f2 || \
51            grep address $(lxc_rootfs $name)/etc/network/interfaces | sed 's/.*address //' ) | \
52            sed -e 's/ *//g' -e 's/\/.*$//'
53    }
54    
55  lxc_status() {  lxc_status() {
56          lxc-ls -1 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do          ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
57                  boot="    "                  boot="-"
58                  test -s /var/lib/lxc/$name/on_boot && boot="boot"                  test -s /var/lib/lxc/$name/on_boot && boot="boot"
59                  echo "$name $status $boot $(lxc_rootfs $name)"                  echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
60          done          done ) | column -t
61  }  }
62    
63    
# Line 53  cleanup_init_scripts() { Line 68  cleanup_init_scripts() {
68                  $rootfs/etc/rc?.d/*umountfs \                  $rootfs/etc/rc?.d/*umountfs \
69                  $rootfs/etc/rc?.d/*umountroot \                  $rootfs/etc/rc?.d/*umountroot \
70                  $rootfs/etc/rc?.d/*hwclock* \                  $rootfs/etc/rc?.d/*hwclock* \
71                    $rootfs/etc/rc?.d/*udev* \
72          2>/dev/null | xargs -i rm -v {}          2>/dev/null | xargs -i rm -v {}
73    
74            echo $1 > $rootfs/etc/hostname
75            grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
76  }  }
77    
78    
# Line 64  setup_inittab() { Line 83  setup_inittab() {
83    
84          # let container respond to kill -SIGPWR          # let container respond to kill -SIGPWR
85          inittab=$rootfs/etc/inittab          inittab=$rootfs/etc/inittab
86          if ! grep "$add" ${inittab} >/dev/null ; then          if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
87                  grep -v "$remove" ${inittab} > ${inittab}.new                  grep -v "$remove" ${inittab} > ${inittab}.new
88                  echo $add >> ${inittab}.new                  echo $add >> ${inittab}.new
89                  mv ${inittab}.new ${inittab}                  mv ${inittab}.new ${inittab}
# Line 102  lxc_stop() { Line 121  lxc_stop() {
121    
122  lxc_start() {  lxc_start() {
123          name=$1          name=$1
124            rootfs=$(lxc_rootfs $1)
125    
126            if [ ! -e $rootfs ] ; then
127                    echo "ERROR $name rootfs $rootfs not found"
128                    return
129            fi
130    
131          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
132                  lxc_log "$name start"                  lxc_log "$name start"
# Line 160  lxc_log "$name watchdog exited" Line 185  lxc_log "$name watchdog exited"
185  }  }
186    
187    
188    usage() {
189            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
190            exit 3
191    }
192    
193  command_on_lxc() {  command_on_lxc() {
194  command=$1  command=$1
195  shift  shift
# Line 171  case "$command" in Line 201  case "$command" in
201  start)  start)
202          lxc_exists $1          lxc_exists $1
203          cleanup_init_scripts $1          cleanup_init_scripts $1
204          setup_inittab $1 ::power      "p0::powerfail:/sbin/init 0"          setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
205          setup_inittab $1 ::ctrlaltdel "p6::ctrlaltdel:/sbin/init 6"          setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
206            setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
207          lxc_start $1          lxc_start $1
208          # give container 5 seconds to start more than one process          # give container 5 seconds to start more than one process
209          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
# Line 194  disable) Line 225  disable)
225          echo -n > /var/lib/lxc/$1/on_boot          echo -n > /var/lib/lxc/$1/on_boot
226          ;;          ;;
227  *)  *)
228          echo "Usage: $0 {start|stop|restart|status}" >&2          usage
         exit 3  
229          ;;          ;;
230    
231  esac  esac
# Line 203  esac Line 233  esac
233  }  }
234    
235  command=$1  command=$1
236  shift  test -z "$command" && usage
   
237  test "$command" = "status" && lxc_status && exit  test "$command" = "status" && lxc_status && exit
238    shift
239    
240  if [ -z "$1" ] ; then  if [ -z "$1" ] ; then
241          ls /var/lib/lxc/*/on_boot | while read path ; do          ls /var/lib/lxc/*/on_boot | while read path ; do

Legend:
Removed from v.189  
changed lines
  Added in v.233

  ViewVC Help
Powered by ViewVC 1.1.26